{% extends "bootstrap/base.html" %}

{% block title %}S2 Level 0 Granule Server{% endblock %}
<meta name='viewport'
      content='initial-scale=1,maximum-scale=1,user-scalable=no'/>

{% block styles %}
{{super()}}



<link rel="stylesheet"
      href="{{ url_for('static', filename='lib/vendor/leaflet/leaflet.css') }}"/>
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3"
      crossorigin="anonymous">

<link rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.37/css/bootstrap-datetimepicker.min.css">
<link rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css">

<link rel="stylesheet" type="text/css"
      href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap5.css">
<link rel="stylesheet"
      href="{{ url_for('static', filename='css/map_filter.css') }}"/>

{% endblock %}
{% block navbar %}
{% include 'nav.html' %}


{% endblock %}


{% block content %}


<div class="jumbotron" style="margin-bottom: 0px;">
    <div class="container-fluid">


        <div class="row">
            <div class="col-md-2">
                <div class="form-group">
                    <label class="control-label">MGRS</label>
                    <input type="text" class="form-control"
                           name="MGRS" id="MGRS_id" >
                </div>
            </div>
            <div class="col-md-2">
                <div class="form-group">
                    <label class="control-label">Orbit</label>
                    <input type="text" class="form-control" name="MGRS"
                           id="ORBIT_id" >
                </div>
            </div>
            <div class='col-md-2'>
                <div class="form-group">
                    <label class="control-label">Start Date</label>
                    <div class='input-group date' id='START_DATE_id'>
                        <input type='text' id='START_DATE_VALUE_id'
                               class="form-control"/>
                        <span class="input-group-addon">
                     <span class="glyphicon glyphicon-calendar"></span>
                     </span>
                    </div>
                </div>
            </div>

            <div class='col-md-2'>
                <div class="form-group">
                    <label class="control-label">End Date</label>
                    <div class='input-group date' id='STOP_DATE_id'>
                        <input type='text' id='STOP_DATE_VALUE_id'
                               class="form-control"/>
                        <span class="input-group-addon">
                     <span class="glyphicon glyphicon-calendar"></span>
                     </span>
                    </div>
                </div>
            </div>

            <div class="col-md-1">
                <div class="form-group">
                    <label class="control-label">Online Only</label>
                    <br>
                    <input type="checkbox" class="form-check-input"
                           name="ONLINE" id="ONLINE_id" value=""
                           >
                </div>
            </div>

            <div class="col-md-2">
                <div class="form-group">
                    <label class="control-label">Max Cloud Coverage (%)</label>
                    <input type="text" class="form-control"
                           name="COVERAGE" id="COVERAGE_id" >
                </div>
            </div>


            <div class="col-md-1">
                <br>
                <button id=SEARCH_id" type="button" onclick="search()"
                        class="btn btn-primary">Search
                </button>
            </div>
        </div>

    </div>
</div>
<button type="button" class="accordion-button text-light bg-dark" id="myBtn">List of products</button>

    <!-- Collapsible Element HTML -->
    <div class="collapse show" id="myCollapse">
        <div class="card card-body">
            <table id="dataId" class="table table-striped">
                    <thead>
                    <tr>
                        <th>Name</th>
                        <th>Orbit</th>
                        <th>Start Date</th>
                        <th>Stop Date</th>
                        <th>Online</th>
                        <th>Size</th>
                        <th>Cloud Coverage</th>
                        <th>Action</th>
                        <th>Polygon</th>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
             <div class="col-md-1" id="DOWNLOAD_BLOCK_id">
                <button id="DOWNLOAD_id" type="button" onclick="download_all()"
                        class="btn btn-primary">Download All
                </button>
                 </div>
           </div>
    </div>

<div id="map_id"> <!--style="width: 50%; height: 50%"> -->

</div>


{% endblock %}
{% block scripts %}
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js">
</script>
<script type="text/javascript"
        src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.18.1/moment.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>

<script type="text/javascript" charset="utf8"
        src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.js"></script>
<script type="text/javascript" charset="utf8"
        src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap5.js"></script>

<link rel="stylesheet"
      href="http://cdn.leafletjs.com/leaflet/v0.7.7/leaflet.css"/>
<script src="http://cdn.leafletjs.com/leaflet/v0.7.7/leaflet.js"></script>
<script type="text/javascript"
        src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.47/js/bootstrap-datetimepicker.min.js"></script>
<script src="{{ url_for('static', filename='lib/vendor/spin.js/spin.js') }}">
</script>
<script src="{{ url_for('static', filename='lib/vendor/leaflet/leaflet.js') }}">
</script>
<script src="{{ url_for('static', filename='lib/Leaflet-WMS.js') }}">
</script>
<script src="{{ url_for('static', filename='js/map_filter.js') }}">

</script>

<script>

   var map;
   var polygon_show = Object.create({});
   var page_length = 10;

   $(document).ready(function() {

    const container = document.getElementById('map_id')
    // Create leaflet map.
    map = new L.Map(container,
        {
        minZoom: 2,
        maxBounds: [ [-90, -180], [90, 180] ],
        maxBoundsViscosity: 1.0,
        noWrap: true
        });
    // Create & add OSM layer.
     var osm = new L.TileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png',
        {
        noWrap: true
        }
        ).addTo(map);

    // Create & add s2tiles layer.
    var s2tiles = new L.TileLayer.WMS('https://geoserver.swarm.ops.internal.gael.fr/geoserver/demo/wms?',
        {
        transparent: true,
        layers: 'mgrs_region',
        opacity: 0.2,
        maxBounds: [ [-90, -180], [90, 180] ],
        bounds: [ [-90, -180], [90, 180] ],
        noWrap: true,
        format: 'image/png'
        }
        ).addTo(map);
    map.setView([50, 9], 4)



    //map.fitWorld();
    // Handle click on map.
    map.on('click', function (e) {
        var properties = {};
        // Send 'GetFeatureInfo' requests.

        s2tiles.getFeatureInfo({
          latlng: e.latlng,
          done: function (featuresCollection, xhr) {
            var result = createMarkingWhenDone(this, featuresCollection);
            properties = result;

              if ('GRID1MIL' in properties) {

              var finalPopupContent = '<b>MGRS:</b> ' + properties.GRID1MIL+properties.GRID100K ;
               finalPopupContent += '<br><b>Lat:</b> ' + properties.LATITUDE + '<br><b>Lon:</b> ' + properties.LONGITUDE

              new L.Popup()
                .setLatLng(e.latlng)
                .setContent(finalPopupContent)
                .openOn(map)
            }
          }
        });


    });

    // Set list hide
    $("#myCollapse").collapse("hide");
    show_download(0);
    updateTable(false);

    // Set datetime
    $('#START_DATE_id').datetimepicker(
        {format: 'YYYY-MM-DDTHH:mm:ss'});

    $('#STOP_DATE_id').datetimepicker(
        {format: 'YYYY-MM-DDTHH:mm:ss'});

    // Methode to toggle collapse
    $("#myBtn").click(function(){
         $("#myCollapse").collapse("toggle");});

    $("#MGRS_id").keypress(enter_click);
    $("#ORBIT_id").keypress(enter_click);
    $("#COVERAGE_id").keypress(enter_click);
    $("#ONLINE_id").keypress(enter_click);
    $("#START_DATE_VALUE_id").keypress(enter_click);
    $("#STOP_DATE_VALUE_id").keypress(enter_click);
    $("#START_DATE_id").keypress(enter_click);
    $("#STOP_DATE_id").keypress(enter_click);

    });

    function enter_click(event) {
        if (event.keyCode === 13) {
            search();
        }
    }

    // Helper methods.
    function createMarkingWhenDone(_this, _featuresCollection) {
      var features = _featuresCollection.features;


      var features = _featuresCollection.features;
      var  feature = features[0]
      if ('GRID1MIL' in feature.properties)
      {
        parent.document.getElementById("MGRS_id").value =
                        feature.properties.GRID1MIL+
                         feature.properties.GRID100K;
      }

      return feature.properties;
    }


    function download_product(id, name) {
            const a = document.createElement('a')
              url = "{{ url_for('download', id='ID_VAR_JS') }}".replace("ID_VAR_JS", id);
              a.href = url
              a.download = name
              document.body.appendChild(a)
              a.click()
              document.body.removeChild(a)
        }
    function search() {
        show_download(0);

        if (check_field()) {

            loadTable();
        }
    }




</script>

{% endblock %}
